#if ! defined(__LKT_CMD_H__)
#define __LKT_CMD_H__

#include <stdnoreturn.h>
#include <stddef.h>

#define CMD_OPT_NULL            { .name = NULL, .call = NULL }
#define CMD_OPT_DEFAULT(func)   { .name = NULL, .call = func }

struct cmd_args {
    int argc;               /* The number of arguments passed.  */
    const char **argv;      /* An array of argument passed.     */
};

typedef void (*cmd_callback)(struct cmd_args *);

struct cmd_opt {
    const char *name;
    cmd_callback call;
};

/* Parse the command line with the list of options. No parameter may be NULL.
   Does not return. */
noreturn void cmd_parse(struct cmd_opt *opts, int argc, const char **argv);

/* Must be setted for the lkt_cmd_parse function to display the correct help
   in case of errors. */
extern const char *executable_name;

/* Prints the help and exit */
noreturn void print_help(void);

#endif /* __LKT_CMD_H__ */
