#if ! defined(__LKT_JSON_H__)
#define __LKT_JSON_H__

/* LIMITATIONS AND SPECIFICATIONS:
 * - parse only one level at the time
 * - values can't be arrays or json objects
 * - " toto tata" => one string ' toto tata'
 * - toto tata => two strings 'toto' and 'tata'
 * - to separate a value from a key, the '=' and ':' separators are not
 *   mendatory, a simple space is enaugth
 * - all values are be strings */

// *INDENT-OFF*
typedef void(*json_parse_callback)(
        const char *key,        /* Json key, a string                               */
        const char *value,      /* Json value, a string                             */
        int completed,          /* 1 when all values in the object has been parsed  */
        void *user              /* The user pointer from the parse function         */
);
// *INDENT-ON*

/* Parse only one level of json, simple but only what we need for lektor. The
 * callback is used when a couple key/value is found for the correct level.
 * When the json object has been completed, call the callback with the
 * 'completed' argument at 1, 'key' and 'value' will be NULL. */
int json_parse(const char *str, int level, json_parse_callback, void *user);

/* Get the object count at the specified level of the json. */
int json_parse_get_count(const char *str, int level);

#endif /* __LKT_JSON_H__ */
