#define _POSIX_C_SOURCE 200809L

#include <lektor/common.h>
#include <lektor/mkv.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

void
mdtcat(struct kara_metadata *mdt, char **ret)
{
    size_t size = strlen(mdt->song_name) + strlen(mdt->source_name) +
                  strlen(mdt->category) + strlen(mdt->language)     +
                  strlen(mdt->author_name) + strlen(mdt->song_type) +
                  /* Null byte */ 1 + /* Separators */ 12 + 5       +
                  long_length(mdt->song_number);
    *ret = malloc(sizeof(char) * size);
    if (!*ret) {
        LOG_ERROR("MKV", "Out of memory");
        return;
    }

    safe_snprintf(*ret, size, "%s - %s / %s - %s%d - %s [%s]", mdt->category,
                  mdt->language, mdt->source_name, mdt->song_type,
                  mdt->song_number, mdt->song_name, mdt->author_name);
}

static const uint8_t __magic[] = { 0x1A, 0x45, 0xDF, 0xA3 };

int
mkv_check_magic(const char *file)
{
    int fd = open(file, O_RDONLY);
    uint8_t buff[4];

    if (fd < 0 || read(fd, &buff, 4) != 4)
        return 1;
    close(fd);
    return mkv_magic(buff);
}

int
mkv_magic(uint8_t tab[4])
{
    return ((tab[0] != __magic[0]) + (tab[1] != __magic[1])) +
           ((tab[2] != __magic[2]) + (tab[3] != __magic[3]));
}
